
#pragma once
#define __STDC_CONSTANT_MACROS

#if defined(_MSC_VER)
typedef unsigned __int64 uint64_t;
#else
#include <inttypes.h>
#endif

void init_timer();

class StopWatch
{
    public:
    int nodes_visited;
    int next_check;

    void set_length(int milliseconds);
    void start();
    uint64_t elapsed();
    bool check_abort();

    private:
    int search_time;
    uint64_t stop_time;
    uint64_t start_time;
    uint64_t last_time;

    int last_check;
};

